#ifndef RATIONAL_HPP // vdelem a tbbszrs behelyezs ellen
#define RATIONAL_HPP

#include <iostream>
// nincs nvtrhasznlat megadva

// racionlis szm tpusa:
class Rational
{
private: // a mezk s a segdmveltek rejtettek
    int _numerator;
    int _denominator;

    void simplify(int& a, int& b); // egyszersts

    // bart mveletek:
    friend Rational operator+(int e, Rational r);
    friend Rational operator*(int e, Rational r);
    friend std::istream& operator>>(std::istream& s, Rational &r); // jelljk a nvteret
    friend std::ostream& operator<<(std::ostream &s, Rational r);
    friend Rational operator+=(Rational& r1, Rational r2);
    friend Rational operator+=(Rational& r, int e);
    friend int operator+=(int& e, Rational r);
    friend Rational operator*=(Rational& r1, Rational r2);
    friend Rational operator*=(Rational& r, int e);
    friend int operator*=(int& e, Rational r);

public: // a mveletek publikusak
    // konstruktorok:
    Rational();
    Rational(int);
    Rational(int, int);

    // lekrdez s bellt mveletek:
    void setNumerator(int value);
    void setDenominator(int value);
    int numerator();
    int denominator();

    // opertor metdusok:
    Rational operator+(Rational);
    Rational operator+(int);
    Rational operator*(Rational);
    Rational operator*(int);
};

// tovbbi opertorok a tpushoz:
Rational operator+(int e, Rational r);
Rational operator*(int e, Rational r);
std::istream& operator>>(std::istream& s, Rational &r); // jelljk a nvteret
std::ostream& operator<<(std::ostream &s, Rational r);
Rational operator+=(Rational& r1, Rational r2);
Rational operator+=(Rational& r, int e);
int operator+=(int& e, Rational r);
Rational operator*=(Rational& r1, Rational r2);
Rational operator*=(Rational& r, int e);
int operator*=(int& e, Rational r);


#endif // RATIONAL_HPP
